#!/usr/bin/python

# Programmer: Andrew Robert
# Function: Generic method to put a message on a queue.
#           This script is intended to be run from the command line 
#
#       Usage:
#
#        mq_putmsg.py  {host}{port}{queue manager}{queue} {message...} 
#
#       Example:
#      
#        To put a message on a specified queue
#
#        mq_putmsg.py  BONGO 1414 SNOOPY ALT.TEST.Q  "Message" 
#
#
# Version History:
# v1.0 - 04/15/05 - AAR - Initial revision 
#                      
#
#


import pymqi, CMQC, sys, os, string

#
# Test number of arguments passed
#
def test_num_arguments():
    if len(sys.argv) == 1:
        print '\n\t\tInsufficient arguments\n\n\n'
        print '\tStandard Usage:\n'
        print '\tmq_putmsg.py {host}{port}{queue manager} {queue} {messages ... }\n'
        print '\n\tExample:\n'
        print '\tmq_putmsg.py MQIDEV1 1415 ADMIN.TEST.Q "hello there" \n\n'
        sys.exit(1)


  
#
# Determine number of command line parameters passed to program
# and validate key options using called functions
#
test_num_arguments()
arg_array_size =len(sys.argv)
counter=5


#
# Automatically adjust passed values to upper case to reflect queue manager
# naming conventions
#
host   = sys.argv[1]
quemgr = sys.argv[3]
queue  = sys.argv[4]
sys.argv[1] = host.upper()
sys.argv[3] = quemgr.upper()
sys.argv[4] = queue.upper()

#
# Form and set the environmental variable for the connection
#  
command="ADMIN.SVRCONN/TCP/"+sys.argv[1]+"("+sys.argv[2]+")"
os.environ['MQSERVER'] =command 

#
# Form and execute put to queue manager on specified queue
#
qmgr = pymqi.QueueManager()
putQ= pymqi.Queue(qmgr, sys.argv[4])
counter=5


while counter < arg_array_size:
    putQ.put(sys.argv[counter])
    print "Sent Message :",sys.argv[counter]
    counter = counter +1

